//import store from '@/store'
import config from '../config.js'
import {
	getAuth
} from '@/utils/auth'
import {
	Md5
} from 'ts-md5/dist/md5';
import errorCode from '@/utils/errorCode'
import {
	toast,
	showConfirm,
	tansParams
} from '@/utils/common'

let timeout = 10000
const baseUrl = config.baseUrl
const request = config => {

	// 是否需要设置 token
	// const isToken = (config.headers || {}).isToken === false
	config.header = config.header || {}


	//  if (getToken() && !isToken) {
	// config.headers['X-AUTH-SIGN'] = Md5.hashStr(JSON.stringify(config.data) +auth.secret);
	// config.headers['X-AUTH-TOKEN'] = auth.token;
	//  }
	if (getAuth()) {
		config.headers['X-AUTH-SIGN'] = Md5.hashStr(JSON.stringify(config.data) + JSON.parse(getAuth()).secret);
		config.headers['X-AUTH-TOKEN'] = JSON.parse(getAuth()).token;
	}
	return new Promise((resolve, reject) => {
		//  debugger
		uni.request({
				method: config.method || 'get',
				timeout: config.timeout || timeout,
				url: config.baseUrl || baseUrl + config.url,
				data: config.data,
				header: config.headers,
				dataType: 'json'
			}).then(response => {
				const res = response.data;
				// if (error) {
				//   toast('后端接口连接异常')
				//   reject('后端接口连接异常')
				//   return
				// }
				const code = res.code
				// const msg = errorCode[code] || res.data.msg || errorCode['default']
				if (code === 401) {
					showConfirm('登录状态已过期，您可以继续留在该页面，或者重新登录?').then(res => {
						// if (res.confirm) {
						//   store.dispatch('LogOut').then(res => {
						//     uni.reLaunch({ url: '/pages/login' })
						//   })
						// }
						uni.reLaunch({
							url: '/pages/login'
						})
					})
					reject('无效的会话，或者会话已过期，请重新登录。')
				} else if (code === 405) {
					showConfirm('帐号已在其他设备登录').then(res => {
						uni.reLaunch({
							url: '/pages/login'
						})
					})
				} else if (code === 500) {
					reject('500')
				} else if (code !== 0) {
					//   toast(msg)
					reject(code)
				}
				resolve(res)
			})
			.catch(error => {
				let {
					message
				} = error
				if (message === 'Network Error') {
					message = '后端接口连接异常'
				} else if (message.includes('timeout')) {
					message = '系统接口请求超时'
				} else if (message.includes('Request failed with status code')) {
					message = '系统接口' + message.substr(message.length - 3) + '异常'
				}
				toast(message)
				reject(error)
			})
	})
}

export default request